#include <fstream>
#include <string>

#include <parser/Parser.h>
#include <common/SyntaxTree.h>

extern int parse(const char* fileName, parser::ParserContext* context);
extern common::SyntaxTreeNode* Root;

namespace parser {

common::SyntaxTreeNode* generateSyntaxTree(const char* fileName, parser::ParserContext* context)
{
	std::string message = "Syntax tree construction started from file ";
	message.append(fileName);
	Log::getInstance()->logMessage(Log::MSG_REPORT, "Parser", message);
	if (parse(fileName, context) == 0 && Root != NULL)	{
		Log::getInstance()->logMessage(Log::MSG_REPORT, "Parser", "Syntax tree constructed succesfully");
		return Root;
	} else {
		Log::getInstance()->logMessage(Log::MSG_FATAL, "Parser", "Syntax tree construction failed");
		return NULL;
	}
}

} //namespace parser