#include <Syntax2Automata/SyntaxHelpers.h>
#include <common/comm.h>


std::string s2a::converToGlobalName(const std::string& name)
{

	int pos = name.find("data->");
	if (pos == std::string::npos) {
		return name;
	}
	std::string result("globalData->");
	result.append(name.substr(pos + 6,name.length() - pos - 6));
	return result;

}


bool s2a::removeDataPrefix(std::string& str)
{
	int pos = str.find("data->");
	if (pos != std::string::npos) {
		str.erase(pos,6);
        return true;
	}
    return false;
}

void s2a::cleanString(std::string& str)
{
    while(s2a::removeDataPrefix(str))
    {

    }
}


void s2a::extractGlobalNames(std::string& str, common::DataModel* localDataModel)
{
    unsigned int pos = str.find("data->");
    std::string buff;
    while (pos != std::string::npos) {
        buff.clear();
        for (unsigned int i = pos + 6; i < str.length() && common::isCharForVarName(str[i]); ++i) {
            buff += str[i];
        }
        if (!localDataModel->contains(buff)) {
            str.replace(pos, 6, "globalData->");
        }
        pos = str.find("data->", pos + 1);
    }
}