#include <iostream>
#include <fstream>
#include <map>


#include <autolog/autoLog.h>

#define MAX_SUBSYSTEM_NAME_LENGTH 24
#define MAX_LEVEL_NAME_LENGTH 12

std::map<Log::LogLevel,std::string> levelNameMap;
Log* Log::_instance;


void Log::initMessages()
{
	
	/*levelNameMap[Log::MSG_REPORT] = std::string("Report");
	levelNameMap[Log::MSG_WARNING] = std::string("Warning");
	levelNameMap[Log::MSG_ERROR] = std::string("Error");
	levelNameMap[Log::MSG_FATAL] = std::string("Fatal Error");*/
	
}

void Log::logMessage(LogLevel level, const std::string& subsystem, const std::string& message, LogMode target)
{
	std::cout<<levelNameMap[level];//<<" | "<<subsystem<<" : "<<message<<"\n";
	for (unsigned int i = 0; i < MAX_LEVEL_NAME_LENGTH - levelNameMap[level].length(); i++)
	{
		std::cout<<" ";
	}
	std::cout<<" | ";
	std::cout<<subsystem;
	for (unsigned int i = 0; i < MAX_SUBSYSTEM_NAME_LENGTH - subsystem.length(); i++)
	{
		std::cout<<" ";
	}
	std::cout<<" : ";
	std::cout<<message;
	std::cout<<"\n";
}

void autoLog(Log::LogLevel level, const std::string& subsystem, const std::string& message)
{
	Log::getInstance()->logMessage(level, subsystem, message);
}