#ifndef AutomataSystem_h__
#define AutomataSystem_h__

#include <vector>

#include <slicing/ProgramDependencyGraph.h>
#include <common/Automata.h>

namespace common {



struct DataModel;
/**
* Represenation of complete automata system. Stores all automata and
* data models.
*
*/

struct AutomataSystem
{

	std::vector<Automaton* > automata;
	DataModel* globalDataModel;
    std::vector<slicing::ProgramDependencyGraph*> dependencyGraphs;
	
    AutomataSystem():globalDataModel(0){}
    ~AutomataSystem()
    {
        for (unsigned int i = 0; i < automata.size(); ++i)
        {
            delete automata[i];
        }
        for (unsigned int i = 0; i < dependencyGraphs.size(); ++i)
        {
            delete dependencyGraphs[i];
        }

    }
    
    
    void buildPDG()
    {
        for (unsigned int i = 0; i < automata.size(); ++i)
        {
            slicing::ProgramDependencyGraph* graph = new slicing::ProgramDependencyGraph();
            graph->create(automata[i]);
            dependencyGraphs.push_back(graph);
        }
    }
};


} //namespace common

#endif // AutomataSystem_h__