#ifndef AutomatonStateData_h__
#define AutomatonStateData_h__

#include <vector>
#include <string>


namespace common {

struct AutomatonStateData 
{
    static const int MAX_SUBORDINATE_GROUPS = 3;
    
    enum StateType{
        STATE_TYPE_INTERNAL = 0,
        STATE_TYPE_OPERATOR,
        STATE_TYPE_AUTOMATON_CALL,
        STATE_TYPE_CONDITIONAL,
        STATE_TYPE_START_END
    } stateType;
    AutomatonStateData(StateType type): stateType(type),subordinateGroups(0){}
    std::string stringData;

    int subordinateGroups;
    int subordinateStates[MAX_SUBORDINATE_GROUPS];

    std::vector<std::string> changeSet;
    std::vector<std::string> dependsOn;
};

}

#endif // AutomatonStateData_h__