#include <cppunit/BriefTestProgressListener.h>
#include <cppunit/TextTestProgressListener.h>
#include <cppunit/CompilerOutputter.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/TestResult.h>
#include <cppunit/TestResultCollector.h>
#include <cppunit/TestRunner.h>

#include "test_Variable.h"
#include "test_Function.h"
#include "test_AutomatonConverter.h"

CPPUNIT_TEST_SUITE_REGISTRATION( VariableTest );

CPPUNIT_TEST_SUITE_REGISTRATION( FunctionTest );

CPPUNIT_TEST_SUITE_REGISTRATION( Syntax2AutomataTest );



int main(int argc, char *argv[])
{
	
	CPPUNIT_NS::TestResult controller;

	// Add a listener that colllects test result
	CPPUNIT_NS::TestResultCollector result;
	controller.addListener( &result );        

	// Add a listener that print dots as test run.
	CPPUNIT_NS::BriefTestProgressListener progress;
	controller.addListener( &progress );      

	// Add the top suite to the test runner
	CPPUNIT_NS::TestRunner runner;
	runner.addTest( CPPUNIT_NS::TestFactoryRegistry::getRegistry().makeTest() );
	runner.run( controller );

	// Print test in a compiler compatible format.
	CPPUNIT_NS::CompilerOutputter outputter( &result, CPPUNIT_NS::stdCOut() );
	outputter.write(); 

	
	if (result.wasSuccessful()) {
		return 0;
	}
	getc(stdin);
	return -1;

}