#include <cppunit/extensions/HelperMacros.h>

#include <common/Function.h>

class FunctionTest: public CPPUNIT_NS::TestFixture {

	CPPUNIT_TEST_SUITE( FunctionTest );
	CPPUNIT_TEST( test_simpleFunction );
	CPPUNIT_TEST( test_singleParameter );
	CPPUNIT_TEST( test_multipleParameters );
	CPPUNIT_TEST_SUITE_END();
public:
	void test_simpleFunction()
	{
		common::Function func("int main()");
		CPPUNIT_ASSERT(func.name == "main");
		CPPUNIT_ASSERT(func.parameters.size() == 0);
	}
	void test_singleParameter()
	{
		common::Function func("int main(int x)");
		CPPUNIT_ASSERT(func.name == "main");
		CPPUNIT_ASSERT(func.parameters.size() == 1);
		common::Variable var("int x");
		CPPUNIT_ASSERT(var == func.parameters[0]);
	}
	void test_multipleParameters()
	{
		common::Function func("float atan2f(float x, float y)");
		CPPUNIT_ASSERT(func.name == "atan2f");
		CPPUNIT_ASSERT(func.parameters.size() == 2);
		CPPUNIT_ASSERT(func.parameters[1].getType() == "float");
		CPPUNIT_ASSERT(func.parameters[1].getName() == "y");
	}
};