#include <windows.h>
#include <queue>
#include "..\interaction.h"
#include "ADBProcessor.h"
#include "resource.h"
#include "ScintillaProxy.h"

#pragma warning (disable: 4996)

using std::queue;

const char* version = "Tracer v0.25";
const int wnd_width = 800;
const int wnd_height = 600;


//////////////////////////////////////////////////////////////////////////
//External Functions
//////////////////////////////////////////////////////////////////////////

extern "C" bool __declspec(dllexport) registerEnvironment(const CAutoEnvironment *e); //registers environment for tracer to interact with automata
extern "C" void __declspec(dllexport) startTracerControl();

//////////////////////////////////////////////////////////////////////////

unsigned int handleException(unsigned int ex, LPEXCEPTION_POINTERS p);

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
DWORD WINAPI WndThreadFunc(PVOID pvParam);

HRESULT hr;
HWND hw;

HWND hEditBoxWatch;

HWND hMainWnd;

HINSTANCE hInst;
HANDLE hThreadWnd;

CAutoEnvironment env;

void BNextClick();
void BPrevClick();
void BStartClick();
void BEndClick();
void BSlicingClick();

void invalidateWnd();

const int BNextID = 1;
const int BPrevID = 2;
const int BStartID = 3;
const int BEndID = 4;
const int ScintillaID = 5;
const int BSlicingID = 6;

const int EditWatchID = 50;

/*
const int ID_TRACER = 1;
const int ID_DEBUGGER = 2;
const int ID_OS = 3;
*/

//const int IDD_DLG_EXC = 1049;

const int TMSG_END				= 0;
const int TMSG_STEP_FORWARD		= 1;
const int TMSG_STEP_BACKWARD	= 2;
const int TMSG_TO_START			= 3;
const int TMSG_TO_END			= 4;
queue<int> msgq;

//CRITICAL_SECTION cs;

char exception_information[1024];


BOOL APIENTRY DllMain( HMODULE hModule,
					  DWORD  ul_reason_for_call,
					  LPVOID lpReserved
					  )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		hInst = hModule;
		goto dll_main_ex;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		goto dll_main_shutdown;
		break;
	}
	return TRUE;

dll_main_shutdown:
	//DeleteCriticalSection(&cs);
	return TRUE;

dll_main_ex:
	//InitializeCriticalSection(&cs);

	env.getStateNumber = NULL;
	env.printVar = NULL;
	env.stepBackward = NULL;
	env.stepForward = NULL;

	

	hThreadWnd = CreateThread(NULL,1024,WndThreadFunc,NULL,0,NULL);

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////
VOID CALLBACK TimerProc(HWND hWnd, UINT uMsg, UINT_PTR idEvent,DWORD dwTime)
{

}

DWORD WINAPI WndThreadFunc(PVOID pvParam)
{
	char szClassName[] = "TracerClass";

	WNDCLASSEX wc;

	//    
	wc.cbSize        = sizeof(wc);		
	wc.style         = CS_HREDRAW | CS_VREDRAW | CS_GLOBALCLASS;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra	 = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInst;
	wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = szClassName;
	wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

	//   
	if (!RegisterClassEx(&wc)) {
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return TRUE;
	}

	//    
	hMainWnd = CreateWindowEx(0, 
		szClassName, "Tracer", WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
		(HWND)NULL, (HMENU)NULL,
		(HINSTANCE)hInst, NULL
		);

	if (!hMainWnd) {
		MessageBox(NULL, "Cannot create main window", "Error", MB_OK);
		return TRUE;
	}

	//   
	ShowWindow(hMainWnd, SW_SHOW); 
	//	UpdateWindow(hMainWnd);



	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0))  {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	unloadScintillaDll();
	return 0;
}



LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HDC hDC;
	PAINTSTRUCT ps;


	switch (msg)
	{
	case WM_COMMAND:
		_asm
		{
			mov	eax,wParam
			cmp lParam, 0
			jz asm_end
				mov ecx, eax
				and ecx, 0FFFFh
				cmp ecx, EditWatchID
				jz	asm_ewatch
				cmp ecx, BNextID
				jz	asm_bnext
				cmp ecx, BPrevID
				jz	asm_bprev
				cmp ecx, BStartID
				jz	asm_bstart
				cmp ecx, BEndID
				jz	asm_bend
                cmp ecx, BSlicingID
                jz  asm_bslicing
				jmp asm_end

asm_ewatch:
				shr eax,16
				cmp ax,EN_CHANGE
				jnz asm_end
				call invalidateWnd
				jmp asm_end

asm_bnext:
				shr eax,16
				cmp ax, BN_CLICKED
				jnz asm_end
				call BNextClick
				jmp asm_end
				
asm_bprev:
				shr eax,16
				cmp ax, BN_CLICKED
				jnz asm_end
				call BPrevClick
				jmp asm_end			
				
asm_bstart:
				shr eax,16
				cmp ax, BN_CLICKED
				jnz asm_end
				call BStartClick
				jmp asm_end	

asm_bend:
				shr eax,16
				cmp ax, BN_CLICKED
				jnz asm_end
				call BEndClick
				jmp asm_end	
asm_bslicing:
                shr eax,16
                cmp ax, BN_CLICKED
                jnz asm_end
                call BSlicingClick
                jmp asm_end	
asm_end:
		}
		break;

	case WM_CREATE:
		//InvokeCreateEvent(hWnd);
		hw = CreateWindowEx(0,"button","<<",WS_CHILD | BS_DEFPUSHBUTTON | WS_VISIBLE,80,35,64,64,hWnd,(HMENU)BPrevID,hInst,0); //next button
		if (!hw)
		{
			char err[64];
			sprintf(err, "Couldn't create forward button! Error: %08x", GetLastError());
			MessageBox(hWnd, err, "", MB_OK);
			return 0;
		}
		hw = CreateWindowEx(0,"button",">>",WS_CHILD | BS_DEFPUSHBUTTON | WS_VISIBLE,150,35,64,64,hWnd,(HMENU)BNextID,hInst,0); //prev button
		if (!hw)
		{
			char err[64];
			sprintf(err, "Couldn't create backward button! Error: %08x", GetLastError());
			MessageBox(hWnd, err, "", MB_OK);
			return 0;
		}
		hw = CreateWindowEx(0,"button",">>>>>",WS_CHILD | BS_DEFPUSHBUTTON | WS_VISIBLE,220,35,64,64,hWnd,(HMENU)BEndID,hInst,0); //prev button
		if (!hw)
		{
			char err[64];
			sprintf(err, "Couldn't create backward button! Error: %08x", GetLastError());
			MessageBox(hWnd, err, "", MB_OK);
			return 0;
		}
		hw = CreateWindowEx(0,"button","<<<<<",WS_CHILD | BS_DEFPUSHBUTTON | WS_VISIBLE,10,35,64,64,hWnd,(HMENU)BStartID,hInst,0); //prev button
		if (!hw)
		{
			char err[64];
			sprintf(err, "Couldn't create backward button! Error: %08x", GetLastError());
			MessageBox(hWnd, err, "", MB_OK);
			return 0;
		}

        hw = CreateWindowEx(0,"button","Static Slicing",WS_CHILD | BS_DEFPUSHBUTTON | WS_VISIBLE,300,35,128,64,hWnd,(HMENU)BSlicingID,hInst,0); //prev button
        if (!hw)
        {
            char err[64];
            sprintf(err, "Couldn't create slicing button! Error: %08x", GetLastError());
            MessageBox(hWnd, err, "", MB_OK);
            return 0;
        }


		hEditBoxWatch = CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",WS_CHILD | WS_VISIBLE | ES_LEFT | ES_AUTOHSCROLL,10,110,270,24,hWnd,(HMENU)EditWatchID,hInst,0);
		if (!hEditBoxWatch)
		{
			char err[64];
			sprintf(err, "Couldn't create edit for watch! Error: %08x", GetLastError());
			MessageBox(hWnd, err, "", MB_OK);
			return 0;
		}
		loadDll();
		scintillaWnd = CreateWindowEx(WS_EX_CLIENTEDGE,
			"Scintilla","",
			WS_CHILD | WS_VISIBLE |  WS_CLIPCHILDREN,
			10,200,770,360,hWnd,
			(HMENU)ScintillaID, hInst,NULL);

		if (!scintillaWnd) {
			MessageBox(NULL, "Cannot create scintilla window", "Error", MB_OK);
			return TRUE;
		}
		retrieveFunctionPointers(scintillaWnd);
		setEditorStyle();
		loadSourceFile("../testExample.txt");
		adbProcessor.loadADBFile("result.adb");

		SetWindowPos(hWnd, 0, 0, 0, wnd_width, wnd_height, SWP_NOMOVE);


	case WM_PAINT:
		hDC = BeginPaint(hWnd, &ps);

		TextOut(hDC, 100, 5, version, strlen(version));

		{
			if (env.getStateNumber != NULL)
			{
				char temp[128];
				int state = env.getStateNumber();
				sprintf(temp, "Current state: %d", state);
				StateLines lines = adbProcessor.getLinesForState( env.getCurrentAutomatonName(), state);
				setCurrentStateLines(lines.lineStart, lines.lineEnd);
				TextOut(hDC, 10, 165, temp, strlen(temp));

				if (env.getStateNumber != NULL)
				{
					sprintf(temp, "Current Automaton: %s", env.getCurrentAutomatonName().c_str());
					TextOut(hDC, 10, 150, temp, strlen(temp));
				}

				if (env.printVar != NULL)
				{
					char edit_text[128];
					GetWindowText(hEditBoxWatch, edit_text, 128);
					sprintf(temp, "Watch: %s", env.printVar(edit_text).c_str());
					TextOut(hDC, 10, 135, temp, strlen(temp));
				}
			}
		}
		

		EndPaint(hWnd, &ps);
		return 0;

	case WM_TIMER:
		return 0;

	case WM_LBUTTONDOWN:
		//InvokeMouseDownEvent(hWnd, MBTN_LEFT, LOWORD(lParam), HIWORD(lParam));
		return 0;

	case WM_LBUTTONUP:
		//InvokeMouseUpEvent(hWnd, MBTN_LEFT, LOWORD(lParam), HIWORD(lParam));
		return 0;

	case WM_MOUSEMOVE:
		//InvokeMouseMoveEvent(hWnd, LOWORD(lParam), HIWORD(lParam));
		return 0;

	case WM_CLOSE:
		msgq.push(TMSG_END);
		DestroyWindow(hWnd);
		return 0;

	case WM_DESTROY:
		//InvokeDestroyEvent(hWnd);
		
		PostQuitMessage(0);
		return 0;
	case WM_NOTIFY:
		{
			LPNMHDR lpnmhdr = (LPNMHDR) lParam;

			if(lpnmhdr->hwndFrom==scintillaWnd)
			{
				switch(lpnmhdr->code)
				{
				case SCN_CHARADDED:
					/* Hey, Scintilla just told me that a new */
					/* character was added to the Edit Control.*/
					/* Now i do something cool with that char. */
					break;
				}
			}
			return 0;
		}
	default:

		return DefWindowProc(hWnd, msg, wParam, lParam);
	}

	return 0;
}


BOOL CALLBACK ExcDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:

		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_EXC), exception_information);
		return TRUE;

	case WM_COMMAND:

		switch(LOWORD(wParam))
		{
		case ID_TRACER:
			EndDialog(hDlg, ID_TRACER);
			break;
		case ID_DEBUGGER:
			EndDialog(hDlg, ID_DEBUGGER);
			break;
		case ID_OS:
			EndDialog(hDlg, ID_OS);
			break;
		}
		break;
	}
	return FALSE;
}



BOOL CALLBACK SlicingDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
    case WM_INITDIALOG:

        
        return TRUE;

    case WM_COMMAND:

        switch(LOWORD(wParam))
        {
        case IDOK:
            {
                int line;
                BOOL* translated = 0;
                line = GetDlgItemInt(hDlg, IDC_EDIT1, translated, false);
                if (line == 0 && (!translated || !*translated))
                {
                    return FALSE;
                }
                PDGNode* node = adbProcessor.getStateForLine(line);
                if (!node)
                {
                    return FALSE;
                }
                StateLines* slice = 0;
                int lines = adbProcessor.getSliceForState(*node, slice);
                
                repaintText();
                for (int i = 0; i < lines; ++i)
                {
                    selectLines(slice[i].lineStart, slice[i].lineEnd);
                }

                EndDialog(hDlg, IDOK);
                break;
            }
        case IDCANCEL:
            EndDialog(hDlg, IDCANCEL);
            break;
        }
        break;
    }
    return FALSE;
}




void BNextClick()
{
	msgq.push(TMSG_STEP_FORWARD);
}

void BPrevClick()
{
	msgq.push(TMSG_STEP_BACKWARD);
}

void BStartClick()
{
	msgq.push(TMSG_TO_START);
}

void BEndClick()
{
	msgq.push(TMSG_TO_END);	
}

void BSlicingClick()
{
    int handler = DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_SLICING), hMainWnd, SlicingDlgProc);
}


void invalidateWnd()
{
	RECT r;
	r.left = 0;
	r.right = wnd_width;
	r.top = 0;
	r.bottom = wnd_height;

	InvalidateRect(hMainWnd, &r, true);
}


unsigned int handleException(unsigned int ex, LPEXCEPTION_POINTERS p)
{
	invalidateWnd();

	if (ex == EXCEPTION_BREAKPOINT)			//int 3
		return EXCEPTION_CONTINUE_SEARCH;

	char exception_name[255];
	switch (ex)
	{
	case EXCEPTION_INT_DIVIDE_BY_ZERO:
		sprintf(exception_name, "Integer Division by Zero");
		break;
	case EXCEPTION_ACCESS_VIOLATION:
		sprintf(exception_name, "Access Violation");
		break;
	case EXCEPTION_FLT_DIVIDE_BY_ZERO:
		sprintf(exception_name, "Float Division by Zero");
		break;
	case EXCEPTION_FLT_OVERFLOW:
		sprintf(exception_name, "Float Type Overflow");
		break;
	case EXCEPTION_FLT_STACK_CHECK:
		sprintf(exception_name, "Stack Overflow or Underflow during Floating Point Operation ");
		break;
	case EXCEPTION_FLT_UNDERFLOW:
		sprintf(exception_name, "Float Type Underflow");
		break;
	case EXCEPTION_INT_OVERFLOW:
		sprintf(exception_name, "Integer Type Overflow");
		break;
	case EXCEPTION_STACK_OVERFLOW:
		sprintf(exception_name, "Thread Stack Overflow");
		break;

	default:
		sprintf(exception_name, "Unknown Exception");
	}

	sprintf(exception_information, "\n\nException Information:\n\nID:\t\t0x%08X\nType:\t\t%s\n", ex, exception_name);

	int handler = DialogBox(hInst, MAKEINTRESOURCE(IDD_DLG_EXC), hMainWnd, ExcDlgProc);

	if (handler == ID_OS)
		return EXCEPTION_CONTINUE_SEARCH;

	if (handler == ID_DEBUGGER)
	{
		_asm
		{
			int 3
		}
		return EXCEPTION_CONTINUE_EXECUTION;
	}	

	if (handler == ID_TRACER)
	{
		return EXCEPTION_EXECUTE_HANDLER;
	}
	return EXCEPTION_CONTINUE_SEARCH;
}






//////////////////////////////////////////////////////////////////////////
//Exporting Functions
//////////////////////////////////////////////////////////////////////////

bool registerEnvironment(const CAutoEnvironment *e)
{
	env = *e;
	return true;
}

void startTracerControl()
{
	char temp[255];
	sprintf(temp, "%s successfully loaded!\n", version);
	printf(temp);
	while (true)
	{
		while (msgq.empty()) Sleep(100);
		int msg = msgq.front();
		msgq.pop();

		switch (msg)
		{
		case TMSG_END:

			goto tracer_control_end;

		case TMSG_STEP_FORWARD:
			
			__try
			{
				env.stepForward(1);
				invalidateWnd();
			}
			__except(handleException(GetExceptionCode(), GetExceptionInformation()))
			{
			}
			break;

		case TMSG_STEP_BACKWARD:

			__try
			{
				env.stepBackward(1);
				invalidateWnd();
			}
			__except(handleException(GetExceptionCode(), GetExceptionInformation()))
			{
			}
			break;

		case TMSG_TO_START:

			__try
			{
				env.toStart();
				invalidateWnd();
			}
			__except(handleException(GetExceptionCode(), GetExceptionInformation()))
			{
			}
			break;

		case TMSG_TO_END:
			
			__try
			{
				env.toEnd();
				invalidateWnd();
			}
			__except(handleException(GetExceptionCode(), GetExceptionInformation()))
			{
			}
			break;

		default:
			char temp[64];
			sprintf(temp, "Unknown Message ID: %08x", msg);
			MessageBox(hMainWnd, temp, "", MB_OK);
		}
	}

tracer_control_end:
	return;
}

