#include "Logger.h"
#include "tracer_v2.h"

extern Tracer_v2* pApp;

Logger logger;

const char* logLevelStrings[5] = {"Error:", "Warning:", "Report:", "Information:", ""};

void Logger::init()
{
    QObject::connect(this, SIGNAL(sendDebugStr(const QString&)), pApp, SLOT(outputDebugStr(const QString&)));
    _isInited = true;
}

void Logger::logLine(MsgType type, const std::string& str)
{
    if (!_isInited) {
        return;
    }

    QString resultStr = logLevelStrings[type];
    resultStr.append(" ").append(str.c_str());

    emit sendDebugStr(resultStr);
}

void Logger::logLine( MsgType type, const QString& str )
{
    if (!_isInited) {
        return;
    }
    QString resultStr = logLevelStrings[type];
    resultStr.append(" ").append(str);

    emit sendDebugStr(resultStr);
}

QString Logger::_getIndentationString()
{
    return " ";
}

void Logger::logDelimeterString()
{

}
