#ifndef Logger_h__
#define Logger_h__

#include <string>
#include <qt/QString.h>
#include <qt/qobject.h>

class Logger: public QObject {
    Q_OBJECT

    int _currentIndent;
    QString _getIndentationString();
    bool _isInited;

public:
    enum MsgType {
        MSG_ERROR = 0,
        MSG_WARNING,
        MSG_REPORT,
        MSG_INFO,
        MSG_NONE
    };

    Logger(): _currentIndent(0), _isInited(false)
    {

    }

    void init();

    void logLine(MsgType type, const std::string& str);

    void logLine(MsgType type, const QString& str);

    void logDelimeterString();
    
signals:
    void sendDebugStr(const QString& str);
    void signal();
};

extern Logger logger;


#endif // Logger_h__